var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
/// <reference path="../typings/phaser.d.ts" />
/// <reference path="../typings/globals/jquery/index.d.ts" />
var gameRatio = window.innerWidth / window.innerHeight;
var w = window.innerWidth * window.devicePixelRatio;
var h = window.innerHeight * window.devicePixelRatio;
/**
 * App
 */
var LosPlantas;
/**
 * App
 */
(function (LosPlantas) {
    LosPlantas.PLANT_MAX_VALUE = 100;
    LosPlantas.PLANT_MIN_VALUE = 0;
    LosPlantas.PLANT_START_VALUE = 50;
    LosPlantas.MINIGAME_BATH = '0';
    LosPlantas.MINIGAME_KITCHEN = '1';
    LosPlantas.MINIGAME_BABYSITTER = '2';
    LosPlantas.MINIGAME_TV = '3';
    LosPlantas.SIZE_ROOMS = {
        width: 400,
        height: 200
    };
    LosPlantas.POS_LIVING_ROOM = {
        x: 102 + 200,
        y: 385 + 100
    };
    LosPlantas.POS_BATH_ROOM = {
        x: 522 + 200,
        y: 165 + 100
    };
    LosPlantas.POS_PLANTS = {
        x: 522 + 200 + 40,
        y: 165 + 100 - 120 - 40 - 36
    };
    LosPlantas.POS_KITCHEN = {
        x: 522 + 200,
        y: 385 + 100
    };
    LosPlantas.POS_BED_ROOM = {
        x: 102 + 200,
        y: 165 + 100
    };
    LosPlantas.POS_ATTIC = {
        x: 102 + 262,
        y: 165 + 100 - 120 - 40 - 36
    };
    LosPlantas.timerFont = {
        font: "60px Ruda,Arial", fill: "#5073d5",
        align: "left",
        fontWeight: "bold",
        boundsAlignH: "left",
        boundsAlignV: "middle",
        wordWrap: false
    };
    var App = (function (_super) {
        __extends(App, _super);
        function App() {
            var _this = this;
            LosPlantas.NPC_FATHER = new LosPlantas.NPC('father_sprite');
            LosPlantas.NPC_FATHER.addAnimation('crazy', [0, 1, 2, 3, 4], 8, true);
            LosPlantas.NPC_MOTHER = new LosPlantas.NPC('mother_sprite');
            LosPlantas.NPC_MOTHER.addAnimation('crazy', [0, 1, 2, 3, 4], 8, true);
            LosPlantas.NPC_BROTHER = new LosPlantas.NPC('brother_sprite');
            LosPlantas.NPC_BROTHER.addAnimation('crazy', [0, 1, 2, 3, 4], 8, true);
            LosPlantas.NPC_GIRL = new LosPlantas.NPC('girl_idle');
            LosPlantas.NPC_GIRL.addAnimation('idle', [0, 1, 2, 3], 1, true);
            _this = _super.call(this, 1024, 600, Phaser.AUTO, 'content', null) || this;
            _this.state.add('First', LosPlantas.FirstState, false);
            _this.state.add('TheEnd', LosPlantas.EndState, false);
            _this.state.add('Loader', LosPlantas.Loader, false);
            _this.state.add('Menu', LosPlantas.Menu, false);
            _this.state.add('Intro', LosPlantas.Intro, false);
            _this.state.add('MinigameSelection', LosPlantas.MinigameSelection, false);
            _this.state.add('MinigameTransition', LosPlantas.MinigameTransition, false);
            _this.state.add('Minigametv', LosPlantas.Minigametv, false);
            _this.state.add('Minigamebath', LosPlantas.Minigamebath, false);
            _this.state.add('Minigamekitchen', LosPlantas.Minigamekitchen, false);
            _this.state.add('PruebaMinigame', LosPlantas.PruebaMinigame, false);
            LosPlantas.player = new LosPlantas.Player();
            _this.state.start('First');
            return _this;
        }
        return App;
    }(Phaser.Game));
    LosPlantas.App = App;
})(LosPlantas || (LosPlantas = {}));
window.onload = function () {
    $.get('/resources.json', function (data) {
        window.resources = data;
        var app = new LosPlantas.App();
    });
};
var LosPlantas;
(function (LosPlantas) {
    var Minigame = (function (_super) {
        __extends(Minigame, _super);
        function Minigame(mid, level) {
            var _this = _super.call(this) || this;
            _this.mid = mid;
            _this.actualScore = 0;
            _this.hasEnded = false;
            _this.hasWin = false;
            _this.setTargetScore();
            return _this;
        }
        Minigame.prototype.init = function () {
            LosPlantas.player.actualMinigame = this;
        };
        Minigame.prototype.endMiniGame = function () {
            this.hasEnded = true;
            this.hasWin = this.actualScore >= this.targetScore;
            LosPlantas.player.endMinigame();
            this.game.state.start('MinigameSelection');
        };
        Minigame.prototype.setTargetScore = function () {
            this.targetScore = 10;
        };
        return Minigame;
    }(Phaser.State));
    LosPlantas.Minigame = Minigame;
})(LosPlantas || (LosPlantas = {}));
var LosPlantas;
(function (LosPlantas) {
    var NPC = (function () {
        function NPC(key) {
            this.key = key;
            this.sprite = null;
            this.animations = new Array();
        }
        NPC.prototype.addAnimation = function (name, indexs, fps, loop) {
            if (loop === void 0) { loop = false; }
            this.animations.push({
                name: name,
                indexs: indexs,
                fps: fps,
                loop: loop
            });
        };
        NPC.prototype.playAnimation = function (name) {
            // if (!this.sprite)
            //   return console.log('No has creado antes un sprite');
            this.sprite.play(name);
        };
        NPC.prototype.execHorizontalTween = function (game, x, time, f) {
            if (time === void 0) { time = 2000; }
            if (f === void 0) { f = Phaser.Easing.Linear.None; }
            return game.add.tween(this.sprite).to({
                x: x
            }, time, f, true, 0, 9999, true);
        };
        NPC.prototype.insertInWorld = function (game, x, y, width, height, frame) {
            var _this = this;
            if (frame === void 0) { frame = 0; }
            this.sprite = game.add.sprite(x, y, this.key, frame);
            this.sprite.anchor.set(0.5, 0.5);
            if (!!width && !!height) {
                this.sprite.width = width;
                this.sprite.height = height;
            }
            this.animations.forEach(function (animationData) {
                _this.sprite.animations.add(animationData.name, animationData.indexs, animationData.fps, animationData.loop);
            });
        };
        return NPC;
    }());
    LosPlantas.NPC = NPC;
})(LosPlantas || (LosPlantas = {}));
var LosPlantas;
(function (LosPlantas) {
    var Player = (function () {
        function Player() {
            this.playedMinigames = new Array();
            this.PlantaActualValue = 5;
            this.PlantaPreviousValue = 0;
        }
        Player.prototype.setMinigame = function (actualMinigame) {
        };
        Player.prototype.endMinigame = function () {
            this.PlantaPreviousValue = this.PlantaActualValue;
            if (this.actualMinigame.hasWin) {
                this.PlantaActualValue += this.actualMinigame.level || 1;
            }
            else {
                this.PlantaActualValue -= this.actualMinigame.level || 1;
            }
            this.playedMinigames.push({
                hasWin: this.actualMinigame.hasWin,
                level: this.actualMinigame.level,
                mid: this.actualMinigame.mid
            });
            this.actualMinigame = null;
        };
        return Player;
    }());
    LosPlantas.Player = Player;
})(LosPlantas || (LosPlantas = {}));
var LosPlantas;
(function (LosPlantas) {
    function loadResources(game) {
        window.resources.images.forEach(function (image) {
            game.load.image(image[0], image[1]);
        });
        window.resources.text.forEach(function (text) {
            game.load.text(text[0], text[1]);
        });
        window.resources.json.forEach(function (json) {
            game.load.json(json[0], json[1]);
        });
        window.resources.videos.forEach(function (video) {
            game.load.video(video[0], video[1]);
        });
        window.resources.spritesheets.forEach(function (spritesheet) {
            game.load.spritesheet(spritesheet.name, spritesheet.url, spritesheet.width, spritesheet.height, spritesheet.qt);
        });
    }
    LosPlantas.loadResources = loadResources;
    function showVibes(game, isGood, reversed, qt, duration, x, y, opacity) {
        if (isGood === void 0) { isGood = false; }
        if (reversed === void 0) { reversed = false; }
        if (qt === void 0) { qt = 1; }
        if (duration === void 0) { duration = 1; }
        if (opacity === void 0) { opacity = 1; }
        var _loop_1 = function (i) {
            if (duration > 0) {
                // console.log('Duration', duration);
                var inter_1 = setInterval(function () {
                    showVibe(game, x, y, isGood, reversed, opacity);
                }, 200);
                setTimeout(function () { return clearInterval(inter_1); }, duration * 1000);
            }
            else {
                showVibe(game, x, y, isGood, reversed, opacity);
            }
        };
        for (var i = 0; i < qt; i++) {
            _loop_1(i);
        }
    }
    LosPlantas.showVibes = showVibes;
})(LosPlantas || (LosPlantas = {}));
function showVibe(game, x, y, isGood, reversed, opacity) {
    if (reversed === void 0) { reversed = false; }
    if (opacity === void 0) { opacity = 1; }
    var posX = 0;
    var posY = 0;
    var vibe = null;
    if (!!x && !!y) {
        posX = x;
        posY = y;
    }
    else {
        posX = (Math.random() * 1024);
        posY = (Math.random() * 600);
    }
    vibe = game.add.sprite(posX, posY, ((isGood) ? 'good' : 'bad') + '_vibe');
    vibe.anchor.set(0.5, 0.5);
    if (!reversed) {
        vibe.alpha = opacity;
        vibe.height = 0;
        vibe.width = 0;
    }
    else {
        vibe.alpha = 0;
        vibe.height = 300;
        vibe.width = 300;
    }
    var postStatus = { alpha: 0, width: 300, height: 300 };
    if (reversed) {
        postStatus = { alpha: opacity, width: 0, height: 0 };
    }
    game.add.tween(vibe).to(postStatus, 2000, Phaser.Easing.Linear.None, true, 0, 0);
}
var LosPlantas;
(function (LosPlantas) {
    var FirstState = (function (_super) {
        __extends(FirstState, _super);
        function FirstState() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FirstState.prototype.preload = function () {
            this.game.load.image('loading', '/asset/backgrounds/LOADING.png');
        };
        FirstState.prototype.create = function () {
            this.game.state.start('Loader');
        };
        return FirstState;
    }(Phaser.State));
    LosPlantas.FirstState = FirstState;
})(LosPlantas || (LosPlantas = {}));
var LosPlantas;
(function (LosPlantas) {
    var TRANSITION_STATE_START = 0;
    var TRANSITION_STATE_WAIT = 100;
    var TRANSITION_STATE_END = 200;
    var TRANSITION_FSM_RATE = 4;
    var Intro = (function (_super) {
        __extends(Intro, _super);
        function Intro() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Intro.prototype.create = function () {
            // const video = this.game.add.video('introVideo');
            this.localState = TRANSITION_STATE_START;
            this.localTimer = this.game.time.events.loop(Phaser.Timer.SECOND * (1 / TRANSITION_FSM_RATE), this.doGameLogic, this);
            this.localTimer.timer.start();
            this.game.add.image(0, 0, 'back_intro');
            LosPlantas.NPC_FATHER.insertInWorld(this.game, LosPlantas.POS_KITCHEN.x, LosPlantas.POS_KITCHEN.y + 20, 120, 120);
            LosPlantas.NPC_FATHER.playAnimation('crazy');
            LosPlantas.NPC_BROTHER.insertInWorld(this.game, LosPlantas.POS_BATH_ROOM.x, LosPlantas.POS_BATH_ROOM.y + 20, 120, 120);
            LosPlantas.NPC_BROTHER.playAnimation('crazy');
            LosPlantas.NPC_MOTHER.insertInWorld(this.game, LosPlantas.POS_LIVING_ROOM.x, LosPlantas.POS_LIVING_ROOM.y + 20, 120, 120);
            LosPlantas.NPC_MOTHER.playAnimation('crazy');
            var plants = new Array();
            for (var i = 0; i < 10; i++) {
                var plant = new LosPlantas.NPC('plant');
                plant.addAnimation('goBad', [0, 1, 2], 6, false);
                plant.insertInWorld(this.game, LosPlantas.POS_PLANTS.x - 160 + (i * 35), LosPlantas.POS_PLANTS.y);
                plants.push(plant);
            }
            // showVibes(this.game, false, true, 10, 2);
            // showVibes(this.game, false, false, 1, 2, POS_KITCHEN.x, POS_KITCHEN.y, 0.12);
            // showVibes(this.game, false, false, 1, 2, POS_BATH_ROOM.x, POS_BATH_ROOM.y, 0.12);
            // showVibes(this.game, false, false, 1, 2, POS_LIVING_ROOM.x, POS_LIVING_ROOM.y, 0.12);
            // showVibes(this.game, false, false, 1, 2, POS_BED_ROOM.x, POS_BED_ROOM.y, 0.12);
            this.game.state.start('MinigameSelection');
            //this.game.state.start('MinigameSelection');
            /*
            video.play();
      
            // video.addToWorld();
      
            video.onComplete.add(() => {
              this.game.state.start('MinigameSelection');
            });
            */
        };
        Intro.prototype.doGameLogic = function () {
            switch (this.localState) {
                case TRANSITION_STATE_START:
                    break;
                case TRANSITION_STATE_WAIT:
                    break;
                case TRANSITION_STATE_END:
                    break;
            }
        };
        return Intro;
    }(Phaser.State));
    LosPlantas.Intro = Intro;
})(LosPlantas || (LosPlantas = {}));
var LosPlantas;
(function (LosPlantas) {
    var Loader = (function (_super) {
        __extends(Loader, _super);
        function Loader() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Loader.prototype.init = function () {
            this.game.add.image(0, 0, 'loading');
            this.stylePreload = {
                font: "30px Ruda,Arial",
                fill: "#FFF",
                align: "center",
                fontWeight: "bold",
                boundsAlignH: "center",
                boundsAlignV: "middle",
                wordWrap: false
            };
            this.game.stage.backgroundColor = "#000";
            // this.preloadTitle = this.game.add.text(0,0,"LosPlantas",this.stylePreload);
            // this.preloadTitle.setTextBounds(this.game.world.centerX - 200, this.game.world.centerY - 60,400, 40);
            this.preloadText = this.game.add.text(0, 0, "Loading", this.stylePreload);
            this.preloadText.setTextBounds(this.game.world.centerX - 200, this.game.world.centerY + 60 - 60, 400, 40);
        };
        Loader.prototype.preload = function () {
            LosPlantas.loadResources(this.game);
        };
        Loader.prototype.loadUpdate = function () {
            this.preloadText.text = "Loading " + this.game.load.progress + " %";
        };
        Loader.prototype.create = function () {
            this.game.add.image(0, 0, 'loading');
            this.game.state.start('Menu', true, false);
        };
        return Loader;
    }(Phaser.State));
    LosPlantas.Loader = Loader;
})(LosPlantas || (LosPlantas = {}));
var LosPlantas;
(function (LosPlantas) {
    var Menu = (function (_super) {
        __extends(Menu, _super);
        function Menu() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Menu.prototype.create = function () {
            this.game.add.image(0, 0, 'menu');
            var head_father = new LosPlantas.NPC('head_father');
            head_father.addAnimation('menu', [0, 1, 2, 1], 2, true);
            head_father.insertInWorld(this.game, 312, 150);
            head_father.playAnimation('menu');
            var head_mother = new LosPlantas.NPC('head_mother');
            head_mother.addAnimation('menu', [0, 1, 2, 1], 2, true);
            head_mother.insertInWorld(this.game, 712, 150);
            head_mother.playAnimation('menu');
            var head_brother = new LosPlantas.NPC('head_brother');
            head_brother.addAnimation('menu', [0, 1, 2, 1], 2, true);
            head_brother.insertInWorld(this.game, 112, 300);
            head_brother.playAnimation('menu');
            var head_girl = new LosPlantas.NPC('head_girl');
            head_girl.addAnimation('menu', [0, 1, 2, 1], 2, true);
            head_girl.insertInWorld(this.game, 512, 100);
            head_girl.playAnimation('menu');
            var head_baby = new LosPlantas.NPC('head_baby');
            head_baby.addAnimation('menu', [0, 1, 2, 1], 2, true);
            head_baby.insertInWorld(this.game, 912, 300);
            head_baby.playAnimation('menu');
            var style = {
                font: "30px Ruda,Arial",
                fill: "#FFF",
                align: "center",
                fontWeight: "bold",
                boundsAlignH: "center",
                boundsAlignV: "middle",
                wordWrap: false
            };
            var text = this.game.add.text(this.game.world.centerX, 420, 'GLOBAL GAME JAM 2017\nhttp://globalgamejam.org/2017/games/good-vibes', style);
            text.anchor.set(0.5, 0.5);
            text.inputEnabled = true;
            text.input.useHandCursor = true;
            text.setShadow(2, 2, '#444', 2);
            text.events.onInputOver.add(function () {
                text.fill = '#eee';
                text.setShadow(2, 2, '#000', 6);
            }, this);
            text.events.onInputOut.add(function () {
                text.fill = '#fff';
                text.setShadow(2, 2, '#444', 2);
            }, this);
            text.events.onInputDown.add(function () {
                window.location.href = 'http://globalgamejam.org/2017/games/good-vibes';
            }, this);
            this.game.add.button(437, 450, 'play_button_menu', this.clickButton, this, 1, 0, 0);
        };
        Menu.prototype.render = function () {
        };
        Menu.prototype.clickButton = function () {
            this.game.state.start('Intro', true, false, this);
        };
        return Menu;
    }(Phaser.State));
    LosPlantas.Menu = Menu;
})(LosPlantas || (LosPlantas = {}));
var LosPlantas;
(function (LosPlantas) {
    var i = 0;
    var FINISHED_SECUENCE = false;
    var MinigameSelection = (function (_super) {
        __extends(MinigameSelection, _super);
        function MinigameSelection() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MinigameSelection.prototype.create = function () {
            // (1024 / 2) - 420 = 92
            // (1024 / 2) + 20 = 532
            // (600 / 2) - 220 = 80
            // (600 / 2) + 20 = 320
            var _this = this;
            this.game.add.image(0, 0, 'back_intro');
            LosPlantas.NPC_GIRL.insertInWorld(this.game, LosPlantas.POS_ATTIC.x - 200, LosPlantas.POS_ATTIC.y + 20, 120, 120);
            LosPlantas.NPC_GIRL.playAnimation('idle');
            var plants = new Array();
            for (var i = 0; i < 10; i++) {
                var plant = new LosPlantas.NPC('plant');
                plant.addAnimation('goBad', [0, 1, 2], 6, false);
                plant.addAnimation('goGood', [2, 1, 0], 6, false);
                plant.insertInWorld(this.game, LosPlantas.POS_PLANTS.x - 160 + (i * 35), LosPlantas.POS_PLANTS.y, 1);
                plants.push(plant);
            }
            this.game.add.image(0, 0, 'back_intro_interior');
            var BED_ROOM_Button = this.game.add.button(LosPlantas.POS_BED_ROOM.x - (LosPlantas.SIZE_ROOMS.width / 2), LosPlantas.POS_BED_ROOM.y - (LosPlantas.SIZE_ROOMS.height / 2), 'far_hab_bed', this.goToBed, this);
            //const BED_ROOM_Background = this.game.add.image(POS_BED_ROOM.x - (SIZE_ROOMS.width / 2), POS_BED_ROOM.y - (SIZE_ROOMS.height / 2), 'back_hab_bed')
            BED_ROOM_Button.alpha = 0;
            var KITCHEN_Button = this.game.add.button(LosPlantas.POS_KITCHEN.x - (LosPlantas.SIZE_ROOMS.width / 2), LosPlantas.POS_KITCHEN.y - (LosPlantas.SIZE_ROOMS.height / 2), 'far_hab_kitchen', this.goToKitchen, this);
            //const KITCHEN_Background = this.game.add.image(POS_KITCHEN.x - (SIZE_ROOMS.width / 2), POS_KITCHEN.y - (SIZE_ROOMS.height / 2), 'back_hab_kitchen')
            KITCHEN_Button.alpha = 0;
            var BATH_ROOM_Button = this.game.add.button(LosPlantas.POS_BATH_ROOM.x - (LosPlantas.SIZE_ROOMS.width / 2), LosPlantas.POS_BATH_ROOM.y - (LosPlantas.SIZE_ROOMS.height / 2), 'far_hab_bath', this.goToBath, this);
            //const BATH_ROOM_Background = this.game.add.image(POS_BATH_ROOM.x - (SIZE_ROOMS.width / 2), POS_BATH_ROOM.y - (SIZE_ROOMS.height / 2), 'back_hab_bath')
            BATH_ROOM_Button.alpha = 0;
            var LIVING_ROOM_Button = this.game.add.button(LosPlantas.POS_LIVING_ROOM.x - (LosPlantas.SIZE_ROOMS.width / 2), LosPlantas.POS_LIVING_ROOM.y - (LosPlantas.SIZE_ROOMS.height / 2), 'far_hab_living', this.goToLivingRoom, this);
            //const LIVING_ROOM_Background = this.game.add.image(POS_LIVING_ROOM.x - (SIZE_ROOMS.width / 2), POS_LIVING_ROOM.y - (SIZE_ROOMS.height / 2), 'back_hab_living')
            LIVING_ROOM_Button.alpha = 0;
            // const ATTIC_Button = this.game.add.button(POS_ATTIC.x - 262, POS_ATTIC.y - 65, 'far_hab_attic', this.goToBath, this);
            // ATTIC_Button.alpha = 0;
            var lastMinigame = null;
            if (LosPlantas.player.playedMinigames.length > 0)
                lastMinigame = LosPlantas.player.playedMinigames[LosPlantas.player.playedMinigames.length - 1];
            if (!!lastMinigame) {
                // first set how many plants are bad
                plants.forEach(function (plant, index) {
                    if (index < (10 - LosPlantas.player.PlantaPreviousValue)) {
                        plant.sprite.frame = 2;
                    }
                    else {
                        plant.sprite.frame = 0;
                    }
                });
                FINISHED_SECUENCE = false;
                var pos = [
                    LosPlantas.POS_BATH_ROOM,
                    LosPlantas.POS_KITCHEN,
                    LosPlantas.POS_BED_ROOM,
                    LosPlantas.POS_LIVING_ROOM
                ][parseInt(lastMinigame.mid)];
                LosPlantas.showVibes(this.game, lastMinigame.hasWin, false, 1, 1, pos.x, pos.y, 0.15);
                setTimeout(function () {
                    plants.forEach(function (plant, index) {
                        if (lastMinigame.hasWin) {
                            if ((index >= (10 - LosPlantas.player.PlantaActualValue)) && (plant.sprite.frame == 2))
                                setTimeout(function () { return plant.playAnimation('goGood'); }, (50 * index) + 1000);
                        }
                        else {
                            if ((index < (10 - LosPlantas.player.PlantaActualValue)) && (plant.sprite.frame == 0))
                                setTimeout(function () { return plant.playAnimation('goBad'); }, (50 * index) + 1000);
                        }
                    });
                    LosPlantas.showVibes(_this.game, (!!lastMinigame) ? lastMinigame.hasWin : false, true, 1, 0.5, LosPlantas.POS_PLANTS.x, LosPlantas.POS_PLANTS.y, 0.25);
                    setTimeout(function () {
                        FINISHED_SECUENCE = true;
                    }, 2000);
                }, 1000);
            }
            else {
                LosPlantas.showVibes(this.game, false, false, 1, 2, LosPlantas.POS_KITCHEN.x, LosPlantas.POS_KITCHEN.y, 0.12);
                LosPlantas.showVibes(this.game, false, false, 1, 2, LosPlantas.POS_BATH_ROOM.x, LosPlantas.POS_BATH_ROOM.y, 0.12);
                LosPlantas.showVibes(this.game, false, false, 1, 2, LosPlantas.POS_LIVING_ROOM.x, LosPlantas.POS_LIVING_ROOM.y, 0.12);
                //showVibes(this.game, false, false, 1, 2, POS_BED_ROOM.x, POS_BED_ROOM.y, 0.12);
                setTimeout(function () {
                    plants.forEach(function (plant, index) {
                        if (index < (10 - LosPlantas.player.PlantaActualValue))
                            setTimeout(function () { return plant.playAnimation('goBad'); }, (50 * index) + 1000);
                    });
                    LosPlantas.showVibes(_this.game, (!!lastMinigame) ? lastMinigame.hasWin : false, true, 1, 0.5, LosPlantas.POS_PLANTS.x, LosPlantas.POS_PLANTS.y, 0.25);
                    setTimeout(function () {
                        FINISHED_SECUENCE = true;
                    }, 2000);
                }, 1000);
            }
            function setFlips(tween, npc, flipFirst) {
                if (flipFirst === void 0) { flipFirst = true; }
                if (flipFirst)
                    npc.sprite.scale.x *= -1;
                tween.onRepeat.add(function () {
                    npc.sprite.scale.x *= -1;
                });
            }
            LosPlantas.NPC_FATHER.insertInWorld(this.game, LosPlantas.POS_KITCHEN.x + 160, LosPlantas.POS_KITCHEN.y + 20 + 15, 120, 120);
            var fatherTween = LosPlantas.NPC_FATHER.execHorizontalTween(this.game, LosPlantas.POS_KITCHEN.x - 160, 3000);
            LosPlantas.NPC_FATHER.playAnimation('crazy');
            setFlips(fatherTween, LosPlantas.NPC_FATHER, false);
            LosPlantas.NPC_BROTHER.insertInWorld(this.game, LosPlantas.POS_BATH_ROOM.x - 160, LosPlantas.POS_BATH_ROOM.y + 20 + 15, 120, 120);
            var brotherTween = LosPlantas.NPC_BROTHER.execHorizontalTween(this.game, LosPlantas.POS_BATH_ROOM.x + 160, 2000);
            LosPlantas.NPC_BROTHER.playAnimation('crazy');
            setFlips(brotherTween, LosPlantas.NPC_BROTHER);
            LosPlantas.NPC_MOTHER.insertInWorld(this.game, LosPlantas.POS_LIVING_ROOM.x - 160, LosPlantas.POS_LIVING_ROOM.y + 20 + 15, 120, 120);
            var motherTween = LosPlantas.NPC_MOTHER.execHorizontalTween(this.game, LosPlantas.POS_LIVING_ROOM.x + 160, 2500);
            LosPlantas.NPC_MOTHER.playAnimation('crazy');
            setFlips(motherTween, LosPlantas.NPC_MOTHER);
        };
        MinigameSelection.prototype.setSecuenceAlert = function (time) {
        };
        MinigameSelection.prototype.render = function () {
            if (!FINISHED_SECUENCE && !this.secuence) {
                this.secuence = this.game.add.image(0, 0, 'secuence');
                this.secuence.alpha = 0.5;
            }
            if (FINISHED_SECUENCE && !!this.secuence) {
                this.secuence.destroy();
                this.secuence = null;
                if (LosPlantas.player.PlantaActualValue >= 10) {
                    LosPlantas.STATUS_MATCH = 'win';
                    this.game.state.start('TheEnd');
                }
                if (LosPlantas.player.PlantaActualValue <= 0) {
                    LosPlantas.STATUS_MATCH = 'lose';
                    this.game.state.start('TheEnd');
                }
            }
        };
        MinigameSelection.prototype.goToBath = function () {
            if (FINISHED_SECUENCE) {
                LosPlantas.player.nextMiniGame = LosPlantas.MINIGAME_BATH;
                this.game.state.start('MinigameTransition', true, false);
            }
        };
        MinigameSelection.prototype.goToKitchen = function () {
            if (FINISHED_SECUENCE) {
                LosPlantas.player.nextMiniGame = LosPlantas.MINIGAME_KITCHEN;
                this.game.state.start('MinigameTransition', true, false);
            }
        };
        MinigameSelection.prototype.goToBed = function () {
            // player.nextMiniGame = MINIGAME_BABYSITTER;
            // this.game.state.start('MinigameTransition', true, false);
        };
        MinigameSelection.prototype.goToLivingRoom = function () {
            if (FINISHED_SECUENCE) {
                LosPlantas.player.nextMiniGame = LosPlantas.MINIGAME_TV;
                this.game.state.start('MinigameTransition', true, false);
            }
        };
        return MinigameSelection;
    }(Phaser.State));
    LosPlantas.MinigameSelection = MinigameSelection;
})(LosPlantas || (LosPlantas = {}));
var LosPlantas;
(function (LosPlantas) {
    var TRANSITION_STATE_START = 0;
    var TRANSITION_STATE_WAIT = 100;
    var TRANSITION_STATE_END = 200;
    var TRANSITION_FSM_RATE = 4; // number of times the FSM is executed per second;
    var MinigameTransition = (function (_super) {
        __extends(MinigameTransition, _super);
        function MinigameTransition() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MinigameTransition.prototype.create = function () {
            this.game.add.image(0, 0, 'transition_bg');
            // console.log(player.nextMiniGame + " " + Date.now().toString());
            this.girlRunSprite = this.add.sprite(this.world.centerX + 700, 200, 'girl_running');
            this.girlRunSprite.anchor.set(0.5, 0.5);
            this.girlRunSprite.animations.add('walk', [0, 1], 6, true);
            this.girlRunSprite.play('walk');
            this.localState = TRANSITION_STATE_START;
            this.localTimer = this.game.time.events.loop(Phaser.Timer.SECOND * (1 / TRANSITION_FSM_RATE), this.doGameLogic, this);
            this.localTimer.timer.start();
        };
        MinigameTransition.prototype.doGameLogic = function () {
            var _this = this;
            switch (this.localState) {
                case TRANSITION_STATE_START:
                    this.girlTween = this.game.add.tween(this.girlRunSprite).to({ x: this.world.centerX - 100, y: 440 }, 750, Phaser.Easing.Linear.None, true);
                    this.girlTween.onComplete.add(function () {
                        _this.game.add.tween(_this.girlRunSprite).to({ x: _this.world.centerX - 700 }, 750, Phaser.Easing.Linear.None, true);
                    });
                    this.localCounter = 0;
                    this.localDuration = 1.5 * TRANSITION_FSM_RATE;
                    this.localState = TRANSITION_STATE_WAIT;
                    break;
                case TRANSITION_STATE_WAIT:
                    if (this.localCounter < this.localDuration) {
                        this.localCounter++;
                    }
                    else {
                        this.localState = TRANSITION_STATE_END;
                    }
                    break;
                case TRANSITION_STATE_END:
                    var phase = void 0;
                    switch (LosPlantas.player.nextMiniGame) {
                        case LosPlantas.MINIGAME_BATH:
                            phase = 'Minigamebath';
                            break;
                        case LosPlantas.MINIGAME_KITCHEN:
                            phase = 'Minigamekitchen';
                            break;
                        case LosPlantas.MINIGAME_TV:
                            phase = 'Minigametv';
                            break;
                        case LosPlantas.MINIGAME_BABYSITTER:
                            phase = 'PruebaMinigame';
                            break;
                        default:
                            phase = 'PruebaMinigame';
                            break;
                    }
                    this.game.state.start(phase, true, false);
                    break;
            }
        }; // end of doGameLogic
        return MinigameTransition;
    }(Phaser.State)); // end of MinigameTransition
    LosPlantas.MinigameTransition = MinigameTransition;
})(LosPlantas || (LosPlantas = {})); // end of module LosPlantas
var LosPlantas;
(function (LosPlantas) {
    var EndState = (function (_super) {
        __extends(EndState, _super);
        function EndState() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        EndState.prototype.create = function () {
            var _this = this;
            var img = null;
            if (LosPlantas.STATUS_MATCH === 'win') {
                img = this.game.add.image(0, 0, 'you_win');
            }
            if (LosPlantas.STATUS_MATCH === 'lose') {
                img = this.game.add.image(0, 0, 'you_lose');
            }
            img.inputEnabled = true;
            img.events.onInputDown.add(function () {
                LosPlantas.player.actualMinigame = null;
                LosPlantas.player.PlantaActualValue = 5;
                LosPlantas.player.playedMinigames = [];
                _this.game.state.start('Menu');
                //window.location.reload();
            }, this);
        };
        return EndState;
    }(Phaser.State));
    LosPlantas.EndState = EndState;
})(LosPlantas || (LosPlantas = {}));
var LosPlantas;
(function (LosPlantas) {
    var MINIGAMEBATH_STATE_START = 0;
    var MINIGAMEBATH_STATE_END = 1000;
    var MINIGAMEBATH_STATE_SUCCESS_START = 10;
    var MINIGAMEBATH_STATE_SUCCESS_WAIT = 11;
    var MINIGAMEBATH_STATE_FAILURE_START = 12;
    var MINIGAMEBATH_STATE_FAILURE_WAIT = 13;
    var MINIGAMEBATH_FSM_RATE = 16; // how many times per second to execute FSM
    var MINIGAMEBATH_TIMER_MAX = 8; // seconds
    var MINIGAMEBATH_WARNING_COLOR1 = '#FF0000';
    var MINIGAMEBATH_WARNING_COLOR2 = '#FFFF00';
    var MINIGAMEBATH_MAX_VIBES = 20;
    var MINIGAMEBATH_MAX_DUCKS = 20;
    var Minigamebath = (function (_super) {
        __extends(Minigamebath, _super);
        function Minigamebath(level) {
            return _super.call(this, LosPlantas.MINIGAME_BATH, level) || this;
        }
        Minigamebath.prototype.setTargetScore = function () {
            // this minigame is about choosing one correct image from an image cycle, so 1 point is enough  
            this.targetScore = 1;
        };
        Minigamebath.prototype.create = function () {
            this.backgroundImage = this.add.image(this.world.centerX, this.world.centerY, 'minigamebath_bg');
            this.backgroundImage.anchor.setTo(0.5, 0.5);
            this.wave1Sprite = this.add.sprite(this.world.centerX + 50, this.world.centerY + 250, 'wave1');
            this.wave1Sprite.anchor.set(0.5, 0.5);
            LosPlantas.NPC_BROTHER.insertInWorld(this.game, this.world.centerX - 400, this.world.centerY + 50, 250, 250);
            LosPlantas.NPC_BROTHER.playAnimation('crazy');
            this.wave1SpriteTween = this.game.add.tween(this.wave1Sprite).to({ x: this.world.centerX, y: this.world.centerY + 230 }, 2000, Phaser.Easing.Circular.InOut, true, 0, -1, true);
            this.wave2Sprite = this.add.sprite(this.world.centerX - 50, this.world.centerY + 265, 'wave2');
            this.wave2Sprite.anchor.set(0.5, 0.5);
            this.wave2SpriteTween = this.game.add.tween(this.wave2Sprite).to({ x: this.world.centerX, y: this.world.centerY + 245 }, 2000, Phaser.Easing.Circular.InOut, true, 0, -1, true);
            var offsetx = 0;
            var offsety = 0;
            var offsetdelay = 0;
            var offsetspeed = 0;
            this.duckSprites = new Array();
            this.duckSpriteTweens = new Array();
            for (var i = 0; i < MINIGAMEBATH_MAX_DUCKS; i++) {
                offsetx = Math.round(Math.random() * 1024);
                offsety = 100 + Math.round(Math.random() * 300);
                offsetdelay = Math.round(Math.random() * 15000);
                offsetspeed = 3000 + Math.round(Math.random() * offsetx) * 3;
                this.duckSprites.push(this.add.sprite(this.world.centerX + 600 + offsetx, this.world.centerY + offsety, 'psychoduck'));
                this.duckSprites[i].anchor.setTo(0.5, 0.5);
                this.duckSprites[i].animations.add("swim", [0, 1, 2, 1], 8, true);
                this.duckSprites[i].animations.add("boom", [3, 4, 5, 6, 7], 8, false);
                this.duckSprites[i].play('swim');
                this.duckSpriteTweens.push(this.game.add.tween(this.duckSprites[i]).to({ x: this.world.centerX - 425, y: this.world.centerY + 50 }, offsetspeed, Phaser.Easing.Linear.None, true, offsetdelay, 0, false));
                this.duckSpriteTweens[i].onComplete.add(this.duckReachesBoy, this);
            }
            //this.knifeSprite = this.add.sprite(this.world.centerX,this.world.centerY+200,'knife');
            //this.knifeSprite.anchor.setTo(0.5,0.5);
            this.vibes = new Array();
            for (var i = 0; i < MINIGAMEBATH_MAX_VIBES; i++) {
                this.vibes.push(this.add.sprite(this.world.centerX + (Math.random() * 1000 - 500), this.world.centerY + (Math.random() * 600 - 300), 'bad_vibe'));
                this.vibes[i].anchor.setTo(0.5, 0.5);
                this.vibes[i].alpha = 1;
                this.vibes[i].height = 0;
                this.vibes[i].width = 0;
            }
            this.input.mouse.capture = true;
            //this.input.mouse.onMouseMove
            this.localDucksShooted = 0;
            this.localCounter = 0;
            this.localState = MINIGAMEBATH_STATE_START;
            this.localTimer = this.game.time.events.loop(Phaser.Timer.SECOND * (1 / MINIGAMEBATH_FSM_RATE), this.doGameLogic, this);
            this.localTimer.timer.start();
        };
        Minigamebath.prototype.duckReachesBoy = function (spr, twn) {
            if (this.localState == MINIGAMEBATH_STATE_START) {
                var stopDucks = false;
                if (spr.frame < 3) {
                    // the duck is intact, game over!!
                    this.localState = MINIGAMEBATH_STATE_FAILURE_START;
                    stopDucks = true;
                }
                else {
                    // the duck is dead, check if the player shooted all the ducks
                    this.localDucksShooted++;
                    if (this.localDucksShooted == MINIGAMEBATH_MAX_DUCKS) {
                        this.localState = MINIGAMEBATH_STATE_SUCCESS_START;
                        stopDucks = true;
                    }
                }
                if (stopDucks) {
                    for (var i = 0; i < MINIGAMEBATH_MAX_DUCKS; i++) {
                        if (this.duckSpriteTweens[i].isRunning) {
                            this.duckSpriteTweens[i].pause();
                        }
                    }
                }
            }
        };
        Minigamebath.prototype.doGameLogic = function () {
            switch (this.localState) {
                case MINIGAMEBATH_STATE_START:
                    if (this.input.activePointer.leftButton.isDown) {
                        // theck if mouse position is near an active duck
                        for (var i = 0; i < MINIGAMEBATH_MAX_DUCKS; i++) {
                            if (this.duckSprites[i].frame < 3) {
                                var deltax = Math.abs(this.input.activePointer.worldX - this.duckSprites[i].x);
                                var deltay = Math.abs(this.input.activePointer.worldY - this.duckSprites[i].y);
                                //console.log("pointer: " + this.input.activePointer.worldX.toString() + 
                                //  " - duck" + this.duckSprites[i].x.toString() + " - " + deltax.toString() + " - " + deltay.toString());
                                if ((deltax < 40) && (deltay < 40)) {
                                    // shoot that duck!
                                    this.duckSprites[i].play('boom');
                                }
                            }
                        }
                    }
                    break;
                case MINIGAMEBATH_STATE_END:
                    this.endMiniGame();
                    break;
                case MINIGAMEBATH_STATE_SUCCESS_START:
                    for (var i = 0; i < MINIGAMEBATH_MAX_VIBES; i++) {
                        this.vibes[i].loadTexture('good_vibe');
                        this.game.add.tween(this.vibes[i]).to({ alpha: 0, width: 300, height: 300 }, 2000, Phaser.Easing.Linear.None, true, 0, 0);
                    }
                    this.actualScore = this.targetScore;
                    this.localCounter = 0;
                    this.localDuration = 2 * MINIGAMEBATH_FSM_RATE;
                    this.localState = MINIGAMEBATH_STATE_SUCCESS_WAIT;
                    break;
                case MINIGAMEBATH_STATE_SUCCESS_WAIT:
                    if (this.localCounter > this.localDuration) {
                        this.localState = MINIGAMEBATH_STATE_END;
                    }
                    else {
                        this.localCounter++;
                    }
                    break;
                case MINIGAMEBATH_STATE_FAILURE_START:
                    for (var i = 0; i < MINIGAMEBATH_MAX_VIBES; i++) {
                        this.game.add.tween(this.vibes[i]).to({ alpha: 0, width: 300, height: 300 }, 2000, Phaser.Easing.Linear.None, true, 0, 0);
                    }
                    this.localCounter = 0;
                    this.localDuration = 2 * MINIGAMEBATH_FSM_RATE;
                    this.localState = MINIGAMEBATH_STATE_FAILURE_WAIT;
                    break;
                case MINIGAMEBATH_STATE_FAILURE_WAIT:
                    if (this.localCounter > this.localDuration) {
                        this.localState = MINIGAMEBATH_STATE_END;
                    }
                    else {
                        this.localCounter++;
                    }
                    break;
            }
        };
        return Minigamebath;
    }(LosPlantas.Minigame));
    LosPlantas.Minigamebath = Minigamebath;
})(LosPlantas || (LosPlantas = {}));
var LosPlantas;
(function (LosPlantas) {
    var PERFECT_STATUS;
    var TIMEOUT_FIRST_STATE;
    var TIMEOUT_SECOND_STATE;
    var TIMEOUT_THIRD_STATE;
    var CROQUETTES_MADE;
    var Minigamekitchen = (function (_super) {
        __extends(Minigamekitchen, _super);
        function Minigamekitchen(level) {
            return _super.call(this, LosPlantas.MINIGAME_KITCHEN, level) || this;
        }
        Minigamekitchen.prototype.setTargetScore = function () {
            this.targetScore = 1;
        };
        Minigamekitchen.prototype.newCroquette = function () {
            var _this = this;
            if (this.actualCroquette)
                this.actualCroquette.destroy();
            this.actualCroquette = this.add.sprite(230, 385, 'croquette_kitchen', 0);
            TIMEOUT_FIRST_STATE = setTimeout(function () {
                _this.actualCroquette.frame = 1;
                TIMEOUT_SECOND_STATE = setTimeout(function () {
                    _this.actualCroquette.frame = 2;
                    TIMEOUT_THIRD_STATE = setTimeout(function () {
                        _this.actualScore = 0;
                        _this.endMiniGame();
                    }, 300);
                }, 250 + (Math.random() * 400));
            }, 2000 + (Math.random() * 400));
        };
        Minigamekitchen.prototype.clearTimeouts = function () {
            if (TIMEOUT_FIRST_STATE !== null)
                clearTimeout(TIMEOUT_FIRST_STATE);
            if (TIMEOUT_SECOND_STATE !== null)
                clearTimeout(TIMEOUT_SECOND_STATE);
            if (TIMEOUT_THIRD_STATE !== null)
                clearTimeout(TIMEOUT_THIRD_STATE);
        };
        Minigamekitchen.prototype.create = function () {
            var _this = this;
            PERFECT_STATUS = false;
            this.add.image(0, 0, 'kitchen_bg');
            LosPlantas.NPC_FATHER.insertInWorld(this.game, 850, 600, 300, 300);
            LosPlantas.NPC_FATHER.playAnimation('crazy');
            CROQUETTES_MADE = 0;
            //this.add.image(360, 260, 'sarten_kitchen');
            this.newCroquette();
            //this.actualCroquette.frame = 0;
            this.add.button(230, 385, 'croquette_button', function () {
                _this.clearTimeouts();
                if (_this.actualCroquette.frame === 1) {
                    CROQUETTES_MADE++;
                    if (CROQUETTES_MADE >= 3) {
                        _this.actualScore = 1;
                        _this.endMiniGame();
                    }
                    else {
                        _this.newCroquette();
                    }
                }
                else {
                    _this.actualScore = 0;
                    _this.endMiniGame();
                }
            });
        };
        return Minigamekitchen;
    }(LosPlantas.Minigame));
    LosPlantas.Minigamekitchen = Minigamekitchen;
})(LosPlantas || (LosPlantas = {}));
var LosPlantas;
(function (LosPlantas) {
    var MINIGAMETV_STATE_START = 0;
    var MINIGAMETV_STATE_END = 1000;
    var MINIGAMETV_STATE_INSTRUCTIONS = 1;
    var MINIGAMETV_STATE_SHOW_REMOTE_START = 2;
    var MINIGAMETV_STATE_SHOW_REMOTE_WAIT = 3;
    var MINIGAMETV_STATE_SHOW_REMOTE_FINISH = 4;
    var MINIGAMETV_STATE_WAIT_USER_SELECTION = 5;
    var MINIGAMETV_STATE_PROCESS_SELECTION = 6;
    var MINIGAMETV_STATE_SUCCESS_START = 7;
    var MINIGAMETV_STATE_SUCCESS_WAIT = 8;
    var MINIGAMETV_STATE_FAILURE_START = 9;
    var MINIGAMETV_STATE_FAILURE_WAIT = 10;
    var MINIGAMETV_FSM_RATE = 16; // how many times per second to execute FSM
    var MINIGAMETV_TIMER_MAX = 20; // seconds
    var MINIGAMETV_WARNING_COLOR1 = '#FF0000';
    var MINIGAMETV_WARNING_COLOR2 = '#FFFF00';
    var MINIGAMETV_MAX_VIBES = 20;
    var Minigametv = (function (_super) {
        __extends(Minigametv, _super);
        function Minigametv(level) {
            return _super.call(this, LosPlantas.MINIGAME_TV, level) || this;
        }
        Minigametv.prototype.setTargetScore = function () {
            // this minigame is about choosing one correct image from an image cycle, so 1 point is enough  
            this.targetScore = 1;
        };
        Minigametv.prototype.create = function () {
            this.backgroundImage = this.add.image(this.world.centerX, this.world.centerY, 'minigametv_bg');
            this.backgroundImage.anchor.setTo(0.5, 0.5);
            this.channelsSprite = this.add.sprite(this.world.centerX + 333, this.world.centerY + 62, 'channels');
            this.channelsSprite.anchor.set(0.5, 0.5);
            this.channelsSprite.animations.add('idle', [
                0, 0, 0, 0, 0, 0, 0, 12, 11, 10,
                1, 1, 1, 1, 1, 1, 1, 12, 11, 10,
                2, 2, 2, 2, 2, 2, 2, 12, 11, 10,
                3, 3, 3, 3, 3, 3, 3, 12, 11, 10,
                4, 4, 4, 4, 4, 4, 4, 12, 11, 10,
                5, 5, 5, 5, 5, 5, 5, 12, 11, 10,
                6, 6, 6, 6, 6, 6, 6, 12, 11, 13,
                7, 7, 7, 7, 7, 7, 7, 12, 11, 10,
                8, 8, 8, 8, 8, 8, 8, 12, 11, 10,
                9, 9, 9, 9, 9, 9, 9, 12, 11, 10
            ], 20, true);
            this.channelsSprite.play('idle');
            this.balloonSprite = this.add.sprite(this.world.centerX - 110, this.world.centerY - 140, 'ui-balloon');
            this.balloonSprite.anchor.set(0.5, 0.5);
            this.channelRequestSprite = this.add.sprite(this.world.centerX - 110, this.world.centerY - 155, 'channels');
            this.channelRequestSprite.anchor.set(0.5, 0.5);
            this.channelRequestSprite.scale.setTo(0.5, 0.5);
            this.channelRequestSprite.frame = Math.round(Math.random() * 10);
            if (this.channelRequestSprite.frame == 10) {
                this.channelRequestSprite.frame = 9;
            }
            this.requestGroup = this.game.add.group();
            this.requestGroup.add(this.balloonSprite);
            this.requestGroup.add(this.channelRequestSprite);
            this.requestGroup.y = this.world.centerY - 220;
            this.game.add.tween(this.requestGroup).to({ y: this.world.centerY - 240 }, 1000, Phaser.Easing.Circular.InOut, true, 0, -1, true);
            this.motherSprite = this.add.sprite(this.world.centerX - 200, this.world.centerY + 135, 'mother_sprite');
            this.motherSprite.anchor.setTo(0.5, 0.5);
            this.motherSprite.animations.add('idle', [0, 1, 2, 3, 4], 8, true);
            this.motherSprite.play('idle');
            this.remoteSprite = this.add.sprite(this.world.centerX + 200, this.world.centerY + 440, 'remote');
            this.remoteSprite.anchor.set(0.5, 0.5);
            this.remoteSprite.animations.add('wait', [0], 1, true);
            this.remoteSprite.animations.add('push', [1], 1, true);
            this.remoteSprite.play('wait');
            this.balloonSprite2 = this.add.sprite(this.world.centerX - 350, this.world.centerY - 50, 'ui-balloon');
            this.balloonSprite2.anchor.setTo(0.5, 0.5);
            this.balloonSprite2.scale.x *= -1;
            this.localSeconds = MINIGAMETV_TIMER_MAX;
            this.timerText = this.add.text(this.world.centerX - 350, this.world.centerY - 60, this.localSeconds.toFixed(2).toString(), LosPlantas.timerFont);
            this.timerText.anchor.setTo(0.5, 0.5);
            this.requestGroup2 = this.game.add.group();
            this.requestGroup2.add(this.balloonSprite2);
            this.requestGroup2.add(this.timerText);
            this.requestGroup2.y = this.world.centerY - 270;
            this.game.add.tween(this.requestGroup2).to({ y: this.world.centerY - 290 }, 1000, Phaser.Easing.Circular.InOut, true, 500, -1, true);
            this.vibes = new Array();
            for (var i = 0; i < MINIGAMETV_MAX_VIBES; i++) {
                this.vibes.push(this.add.sprite(this.world.centerX + (Math.random() * 1000 - 500), this.world.centerY + (Math.random() * 600 - 300), 'bad_vibe'));
                this.vibes[i].anchor.setTo(0.5, 0.5);
                this.vibes[i].alpha = 1;
                this.vibes[i].height = 0;
                this.vibes[i].width = 0;
            }
            this.input.mouse.capture = true;
            this.localCounter = 0;
            this.localState = MINIGAMETV_STATE_START;
            this.localTimer = this.game.time.events.loop(Phaser.Timer.SECOND * (1 / MINIGAMETV_FSM_RATE), this.doGameLogic, this);
            this.localTimer.timer.start();
        };
        Minigametv.prototype.doGameLogic = function () {
            switch (this.localState) {
                case MINIGAMETV_STATE_START:
                    this.localState = MINIGAMETV_STATE_INSTRUCTIONS;
                    break;
                case MINIGAMETV_STATE_END:
                    this.endMiniGame();
                    break;
                case MINIGAMETV_STATE_INSTRUCTIONS:
                    this.localState = MINIGAMETV_STATE_SHOW_REMOTE_START;
                    break;
                case MINIGAMETV_STATE_SHOW_REMOTE_START:
                    this.remoteSpriteTween = this.game.add.tween(this.remoteSprite).to({ y: this.world.centerY + 200 }, 1000, Phaser.Easing.Circular.Out, true);
                    this.remoteSpriteTween.onComplete.add(this.remoteFinishedShowing, this);
                    this.localState = MINIGAMETV_STATE_SHOW_REMOTE_WAIT;
                    break;
                case MINIGAMETV_STATE_SHOW_REMOTE_WAIT:
                    // wait for remote to complete showing...
                    break;
                case MINIGAMETV_STATE_SHOW_REMOTE_FINISH:
                    // put idle remote animation...
                    // prepare game for user interaction
                    this.localDuration = MINIGAMETV_TIMER_MAX * MINIGAMETV_FSM_RATE;
                    this.localCounter = 0;
                    this.timerText.visible = true;
                    this.timerText.text = '0.00';
                    this.localState = MINIGAMETV_STATE_WAIT_USER_SELECTION;
                    break;
                case MINIGAMETV_STATE_WAIT_USER_SELECTION:
                    if (this.input.activePointer.leftButton.isDown) {
                        if (this.channelsSprite.animations.currentAnim.frame > 9) {
                            this.channelsSprite.animations.currentAnim.next(3);
                        }
                        this.channelsSprite.animations.currentAnim.stop();
                        this.localState = MINIGAMETV_STATE_PROCESS_SELECTION;
                        this.remoteSprite.play('push');
                    }
                    // while the user awaits to select the channel requested, change timer
                    if (this.localCounter > this.localDuration) {
                        this.localState = MINIGAMETV_STATE_FAILURE_START;
                    }
                    else {
                        this.localCounter++;
                    }
                    this.localSeconds = MINIGAMETV_TIMER_MAX - (this.localCounter / MINIGAMETV_FSM_RATE);
                    if (this.localSeconds < 0) {
                        this.localSeconds = 0;
                    }
                    if (this.localSeconds < 5) {
                        if ((this.localCounter % 4) == 0) {
                            if (this.localSecondsChangeColor) {
                                this.timerText.addColor(MINIGAMETV_WARNING_COLOR1, 0);
                            }
                            else {
                                this.timerText.addColor(MINIGAMETV_WARNING_COLOR2, 0);
                            }
                            this.localSecondsChangeColor = !this.localSecondsChangeColor;
                        }
                    }
                    this.timerText.text = this.localSeconds.toFixed(2).toString();
                    break;
                case MINIGAMETV_STATE_PROCESS_SELECTION:
                    if (this.channelRequestSprite.frame == this.channelsSprite.frame) {
                        this.localState = MINIGAMETV_STATE_SUCCESS_START;
                    }
                    else {
                        this.localState = MINIGAMETV_STATE_FAILURE_START;
                    }
                    break;
                case MINIGAMETV_STATE_SUCCESS_START:
                    for (var i = 0; i < MINIGAMETV_MAX_VIBES; i++) {
                        this.vibes[i].loadTexture('good_vibe');
                        this.game.add.tween(this.vibes[i]).to({ alpha: 0, width: 300, height: 300 }, 2000, Phaser.Easing.Linear.None, true, 0, 0);
                    }
                    this.actualScore = this.targetScore;
                    this.localCounter = 0;
                    this.localDuration = 2 * MINIGAMETV_FSM_RATE;
                    this.localState = MINIGAMETV_STATE_SUCCESS_WAIT;
                    break;
                case MINIGAMETV_STATE_SUCCESS_WAIT:
                    if (this.localCounter > this.localDuration) {
                        this.localState = MINIGAMETV_STATE_END;
                    }
                    else {
                        this.localCounter++;
                    }
                    break;
                case MINIGAMETV_STATE_FAILURE_START:
                    for (var i = 0; i < MINIGAMETV_MAX_VIBES; i++) {
                        this.game.add.tween(this.vibes[i]).to({ alpha: 0, width: 300, height: 300 }, 2000, Phaser.Easing.Linear.None, true, 0, 0);
                    }
                    this.actualScore = 0;
                    this.localCounter = 0;
                    this.localDuration = 2 * MINIGAMETV_FSM_RATE;
                    this.localState = MINIGAMETV_STATE_FAILURE_WAIT;
                    break;
                case MINIGAMETV_STATE_FAILURE_WAIT:
                    if (this.localCounter > this.localDuration) {
                        this.localState = MINIGAMETV_STATE_END;
                    }
                    else {
                        this.localCounter++;
                    }
                    break;
            }
        };
        Minigametv.prototype.remoteFinishedShowing = function () {
            this.localState = MINIGAMETV_STATE_SHOW_REMOTE_FINISH;
        };
        return Minigametv;
    }(LosPlantas.Minigame));
    LosPlantas.Minigametv = Minigametv;
})(LosPlantas || (LosPlantas = {}));
var LosPlantas;
(function (LosPlantas) {
    var PruebaMinigame = (function (_super) {
        __extends(PruebaMinigame, _super);
        function PruebaMinigame(level) {
            return _super.call(this, 'Prueba', level) || this;
        }
        PruebaMinigame.prototype.setTargetScore = function () {
            this.targetScore = 20;
        };
        PruebaMinigame.prototype.create = function () {
            var _this = this;
            this.add.button(0, 0, 'button1', function () {
                _this.actualScore = 22;
                _this.endMiniGame();
            });
        };
        return PruebaMinigame;
    }(LosPlantas.Minigame));
    LosPlantas.PruebaMinigame = PruebaMinigame;
})(LosPlantas || (LosPlantas = {}));
