
module LosPlantas {  

  export class Loader extends Phaser.State {
    
    game: Phaser.Game;
    preloadText: Phaser.Text;
    preloadTitle: Phaser.Text;
    stylePreload: any;

    init() {
      this.game.add.image(0, 0, 'loading');

      this.stylePreload = {
        font: "30px Ruda,Arial",
        fill: "#FFF",
        align: "center",
        fontWeight: "bold",
        boundsAlignH: "center",
        boundsAlignV: "middle",
        wordWrap: false
      };

      this.game.stage.backgroundColor = "#000";

      // this.preloadTitle = this.game.add.text(0,0,"LosPlantas",this.stylePreload);
      // this.preloadTitle.setTextBounds(this.game.world.centerX - 200, this.game.world.centerY - 60,400, 40);
      this.preloadText = this.game.add.text(0,0,"Loading",this.stylePreload);
      this.preloadText.setTextBounds(this.game.world.centerX - 200, this.game.world.centerY+60 - 60,400, 40);
    }

    preload(){
      loadResources(this.game);
    }

    loadUpdate() {
      this.preloadText.text = "Loading " + this.game.load.progress + " %";
    }

    create(){
      this.game.add.image(0, 0, 'loading');
      this.game.state.start('Menu', true, false);
    }
  }

}
