
module LosPlantas {
  export class Menu extends Phaser.State {

    create(){
      this.game.add.image(0, 0, 'menu');

      let head_father = new NPC('head_father');
      head_father.addAnimation('menu', [0, 1, 2, 1], 2, true);
      head_father.insertInWorld(this.game, 312, 150);
      head_father.playAnimation('menu');
      let head_mother = new NPC('head_mother');
      head_mother.addAnimation('menu', [0, 1, 2, 1], 2, true);
      head_mother.insertInWorld(this.game, 712, 150);
      head_mother.playAnimation('menu');
      let head_brother = new NPC('head_brother');
      head_brother.addAnimation('menu', [0, 1, 2, 1], 2, true);
      head_brother.insertInWorld(this.game, 112, 300);
      head_brother.playAnimation('menu');
      let head_girl = new NPC('head_girl');
      head_girl.addAnimation('menu', [0, 1, 2, 1], 2, true);
      head_girl.insertInWorld(this.game, 512, 100);
      head_girl.playAnimation('menu');
      let head_baby = new NPC('head_baby');
      head_baby.addAnimation('menu', [0, 1, 2, 1], 2, true);
      head_baby.insertInWorld(this.game, 912, 300);
      head_baby.playAnimation('menu');

      const style = {
        font: "30px Ruda,Arial",
        fill: "#FFF",
        align: "center",
        fontWeight: "bold",
        boundsAlignH: "center",
        boundsAlignV: "middle",
        wordWrap: false
      };

      const text = this.game.add.text(this.game.world.centerX, 420, 'GLOBAL GAME JAM 2017\nhttp://globalgamejam.org/2017/games/good-vibes', style);
      text.anchor.set(0.5, 0.5);
      text.inputEnabled = true;
      text.input.useHandCursor = true;
      text.setShadow(2, 2, '#444', 2);
      text.events.onInputOver.add(() => {
        text.fill = '#eee';
        text.setShadow(2, 2, '#000', 6);
      }, this);
      text.events.onInputOut.add(() => {
        text.fill = '#fff';
        text.setShadow(2, 2, '#444', 2);
      }, this);
      text.events.onInputDown.add(() => {
        window.location.href = 'http://globalgamejam.org/2017/games/good-vibes';
      }, this);
      this.game.add.button(437, 450, 'play_button_menu', this.clickButton, this, 1, 0, 0);
    }

    render(){
      
    }

    clickButton(){
      this.game.state.start('Intro', true, false, this);
    }

  }
}
