
interface size {
  x: number,
  y: number
}

module LosPlantas {

  let i = 0;

  let FINISHED_SECUENCE = false;

  export class MinigameSelection extends Phaser.State {

    secuence: Phaser.Image;

    private localTimer : Phaser.TimerEvent;
    
    create(){

      // (1024 / 2) - 420 = 92
      // (1024 / 2) + 20 = 532
      // (600 / 2) - 220 = 80
      // (600 / 2) + 20 = 320

      this.game.add.image(0, 0, 'back_intro');

      NPC_GIRL.insertInWorld(this.game, POS_ATTIC.x - 200, POS_ATTIC.y + 20, 120, 120);
      NPC_GIRL.playAnimation('idle');

      const plants = new Array<NPC>();

      for (var i = 0; i < 10; i++) {
        const plant = new NPC('plant');
        plant.addAnimation('goBad', [0, 1, 2], 6, false);
        plant.addAnimation('goGood', [2, 1, 0], 6, false);
        plant.insertInWorld(this.game, POS_PLANTS.x - 160 + (i * 35), POS_PLANTS.y, 1)
        plants.push(plant);
      }

      this.game.add.image(0, 0, 'back_intro_interior');

      const BED_ROOM_Button = this.game.add.button(POS_BED_ROOM.x - (SIZE_ROOMS.width / 2), POS_BED_ROOM.y - (SIZE_ROOMS.height / 2), 'far_hab_bed', this.goToBed, this);
      //const BED_ROOM_Background = this.game.add.image(POS_BED_ROOM.x - (SIZE_ROOMS.width / 2), POS_BED_ROOM.y - (SIZE_ROOMS.height / 2), 'back_hab_bed')
      BED_ROOM_Button.alpha = 0;
      const KITCHEN_Button = this.game.add.button(POS_KITCHEN.x - (SIZE_ROOMS.width / 2), POS_KITCHEN.y - (SIZE_ROOMS.height / 2), 'far_hab_kitchen', this.goToKitchen, this);
      //const KITCHEN_Background = this.game.add.image(POS_KITCHEN.x - (SIZE_ROOMS.width / 2), POS_KITCHEN.y - (SIZE_ROOMS.height / 2), 'back_hab_kitchen')
      KITCHEN_Button.alpha = 0;
      const BATH_ROOM_Button = this.game.add.button(POS_BATH_ROOM.x - (SIZE_ROOMS.width / 2), POS_BATH_ROOM.y - (SIZE_ROOMS.height / 2), 'far_hab_bath', this.goToBath, this);
      //const BATH_ROOM_Background = this.game.add.image(POS_BATH_ROOM.x - (SIZE_ROOMS.width / 2), POS_BATH_ROOM.y - (SIZE_ROOMS.height / 2), 'back_hab_bath')
      BATH_ROOM_Button.alpha = 0;
      const LIVING_ROOM_Button = this.game.add.button(POS_LIVING_ROOM.x - (SIZE_ROOMS.width / 2), POS_LIVING_ROOM.y - (SIZE_ROOMS.height / 2), 'far_hab_living', this.goToLivingRoom, this);
      //const LIVING_ROOM_Background = this.game.add.image(POS_LIVING_ROOM.x - (SIZE_ROOMS.width / 2), POS_LIVING_ROOM.y - (SIZE_ROOMS.height / 2), 'back_hab_living')
      LIVING_ROOM_Button.alpha = 0;

      // const ATTIC_Button = this.game.add.button(POS_ATTIC.x - 262, POS_ATTIC.y - 65, 'far_hab_attic', this.goToBath, this);
      // ATTIC_Button.alpha = 0;

      let lastMinigame: MinigameStatus = null;

      if (player.playedMinigames.length > 0)
        lastMinigame = player.playedMinigames[player.playedMinigames.length - 1];

      if (!!lastMinigame){
        // first set how many plants are bad
        plants.forEach((plant, index) => {
          if (index < (10 - player.PlantaPreviousValue)) {
            plant.sprite.frame = 2;
          } else {
            plant.sprite.frame = 0;
          }
        })

        FINISHED_SECUENCE = false;

        const pos = [
          POS_BATH_ROOM,
          POS_KITCHEN,
          POS_BED_ROOM,
          POS_LIVING_ROOM
        ][parseInt(lastMinigame.mid)];

        showVibes(this.game, lastMinigame.hasWin, false, 1, 1, pos.x, pos.y, 0.15);
        setTimeout(() => {
            plants.forEach((plant, index) => {
              if (lastMinigame.hasWin) {
                if ((index >= (10 - player.PlantaActualValue)) && (plant.sprite.frame == 2))
                  setTimeout(() => plant.playAnimation('goGood'), (50 * index) + 1000);
              } else {
                if ((index < (10 - player.PlantaActualValue)) && (plant.sprite.frame == 0))
                  setTimeout(() => plant.playAnimation('goBad'), (50 * index) + 1000);
              }
            });
          showVibes(this.game, (!!lastMinigame) ? lastMinigame.hasWin : false, true, 1, 0.5, POS_PLANTS.x, POS_PLANTS.y, 0.25);
          setTimeout(function() {
            FINISHED_SECUENCE = true;
          }, 2000);
        }, 1000);
      }else{
        showVibes(this.game, false, false, 1, 2, POS_KITCHEN.x, POS_KITCHEN.y, 0.12);
        showVibes(this.game, false, false, 1, 2, POS_BATH_ROOM.x, POS_BATH_ROOM.y, 0.12);
        showVibes(this.game, false, false, 1, 2, POS_LIVING_ROOM.x, POS_LIVING_ROOM.y, 0.12);
        //showVibes(this.game, false, false, 1, 2, POS_BED_ROOM.x, POS_BED_ROOM.y, 0.12);
        setTimeout(() => {
            plants.forEach((plant, index) => {
              if (index < (10 - player.PlantaActualValue))
                setTimeout(() => plant.playAnimation('goBad'), (50 * index) + 1000);
            });
            showVibes(this.game, (!!lastMinigame) ? lastMinigame.hasWin : false, true, 1, 0.5, POS_PLANTS.x, POS_PLANTS.y, 0.25);
            setTimeout(function() {
              FINISHED_SECUENCE = true;
            }, 2000);
        }, 1000);
      }
      
      function setFlips(tween: Phaser.Tween, npc: NPC, flipFirst: boolean = true){
        if (flipFirst) npc.sprite.scale.x *= -1;
        tween.onRepeat.add(() => {
          npc.sprite.scale.x *= -1;
        });
      }

      NPC_FATHER.insertInWorld(this.game, POS_KITCHEN.x + 160, POS_KITCHEN.y + 20 + 15, 120, 120);
      const fatherTween = NPC_FATHER.execHorizontalTween(this.game, POS_KITCHEN.x - 160, 3000);
      NPC_FATHER.playAnimation('crazy');
      setFlips(fatherTween, NPC_FATHER, false);

      NPC_BROTHER.insertInWorld(this.game, POS_BATH_ROOM.x - 160, POS_BATH_ROOM.y + 20 + 15, 120, 120);
      const brotherTween = NPC_BROTHER.execHorizontalTween(this.game, POS_BATH_ROOM.x + 160, 2000);
      NPC_BROTHER.playAnimation('crazy');
      setFlips(brotherTween, NPC_BROTHER);

      NPC_MOTHER.insertInWorld(this.game, POS_LIVING_ROOM.x - 160, POS_LIVING_ROOM.y + 20 + 15, 120, 120);
      const motherTween = NPC_MOTHER.execHorizontalTween(this.game, POS_LIVING_ROOM.x + 160, 2500);
      NPC_MOTHER.playAnimation('crazy');
      setFlips(motherTween, NPC_MOTHER);

      
      
    }

    setSecuenceAlert(time: number){
      
    }

    render(){
      if (!FINISHED_SECUENCE && !this.secuence){
        this.secuence = this.game.add.image(0, 0, 'secuence');
        this.secuence.alpha = 0.5;
      }
      if (FINISHED_SECUENCE && !!this.secuence){
        this.secuence.destroy();
        this.secuence = null;
        if (player.PlantaActualValue >= 10) {
          STATUS_MATCH = 'win';
          this.game.state.start('TheEnd');
        }
        if (player.PlantaActualValue <= 0){
          STATUS_MATCH = 'lose';
          this.game.state.start('TheEnd');
        }
      }
    }

    goToBath(){
      if (FINISHED_SECUENCE){
        player.nextMiniGame = MINIGAME_BATH;
        this.game.state.start('MinigameTransition', true, false);
      }
    }
    goToKitchen(){
      if (FINISHED_SECUENCE){
        player.nextMiniGame = MINIGAME_KITCHEN;
        this.game.state.start('MinigameTransition', true, false);
      }
    }
    goToBed(){
      // player.nextMiniGame = MINIGAME_BABYSITTER;
      // this.game.state.start('MinigameTransition', true, false);
    }
    goToLivingRoom(){
      if (FINISHED_SECUENCE){
        player.nextMiniGame = MINIGAME_TV;
        this.game.state.start('MinigameTransition', true, false);
      }
    }

  }

}
