
module LosPlantas {
  let PERFECT_STATUS: boolean;
  let TIMEOUT_FIRST_STATE: number;
  let TIMEOUT_SECOND_STATE: number;
  let TIMEOUT_THIRD_STATE: number;
  let CROQUETTES_MADE: number;
   
  export class Minigamekitchen extends Minigame {
    actualCroquette: Phaser.Sprite;

    constructor(level: number){
      super(MINIGAME_KITCHEN, level);
    }

    setTargetScore(){
      this.targetScore = 1;
    }

    newCroquette(){
      if (this.actualCroquette)
        this.actualCroquette.destroy();
        
      this.actualCroquette = this.add.sprite(230, 385, 'croquette_kitchen', 0);

      TIMEOUT_FIRST_STATE = setTimeout(() => {
        this.actualCroquette.frame = 1;
        TIMEOUT_SECOND_STATE = setTimeout(() => {
          this.actualCroquette.frame = 2;
          TIMEOUT_THIRD_STATE = setTimeout(() => {
            this.actualScore = 0;
            this.endMiniGame();
          }, 300);
        }, 250 + (Math.random() * 400));
      }, 2000 + (Math.random() * 400));
    }

    clearTimeouts(){
      if (TIMEOUT_FIRST_STATE !== null)
        clearTimeout(TIMEOUT_FIRST_STATE); 
      if (TIMEOUT_SECOND_STATE !== null)
        clearTimeout(TIMEOUT_SECOND_STATE); 
      if (TIMEOUT_THIRD_STATE !== null)
        clearTimeout(TIMEOUT_THIRD_STATE); 
    }

    create(){

      PERFECT_STATUS = false;

      this.add.image(0, 0, 'kitchen_bg');

      NPC_FATHER.insertInWorld(this.game, 850, 600, 300, 300);
      NPC_FATHER.playAnimation('crazy');

      CROQUETTES_MADE = 0;

      //this.add.image(360, 260, 'sarten_kitchen');
      
      this.newCroquette();
      //this.actualCroquette.frame = 0;

      this.add.button(230, 385, 'croquette_button', () => {
        this.clearTimeouts();

        if (this.actualCroquette.frame === 1){
          CROQUETTES_MADE++;

          if (CROQUETTES_MADE >= 3){
            this.actualScore = 1;
            this.endMiniGame();
          }else{
            this.newCroquette();
          }
        }else{
          this.actualScore = 0;
          this.endMiniGame();
        }
        
      });
    }

  }

}
